import { Server } from 'socket.io'
import { TSocket } from '../../../../utilities/types'
import { Object } from '@prisma/client'
import ObjectRepository from '../../../../repositories/objectRepository'
import CharacterManager from '../../../../managers/characterManager'
import characterRepository from '../../../../repositories/characterRepository'

interface IPayload {}

/**
 * Handle game master list object event
 * @param socket
 * @param io
 */
export default function (socket: TSocket, io: Server) {
  socket.on('gm:object:list', async (data: any, callback: (response: Object[]) => void) => {
    const character = await characterRepository.getById(socket.characterId as number);
    if (!character) return callback([])

    if (character.role !== 'gm') {
      return callback([])
    }

    // get all objects
    const objects = await ObjectRepository.getAll()
    callback(objects)
  })
}
